IMPLEMENTATION MODULE UTCClk;

IMPORT WinBase;
IMPORT Types, Lib2, Clock;

VAR
  utc: TDateTime;


PROCEDURE CmpDTR( x-, y-: TDateTime ): Types.TShtInt;
BEGIN
  IF x.d < y.d THEN RETURN -1 END;
  IF x.d > y.d THEN RETURN  1 END;
  IF x.t < y.t THEN RETURN -1 END;
  IF x.t > y.t THEN RETURN  1 END;
  RETURN 0;
END CmpDTR;


PROCEDURE UpdDateTime();
VAR
  t: WinBase.SYSTEMTIME;
  x: TDateTime;
BEGIN
  WinBase.GetSystemTime( t );
  x.d := Clock.PackDate( t.wDay, t.wMonth, t.wYear );
  x.t := Clock.PackTime( t.wHour, t.wMinute, t.wSecond, t.wMilliseconds );
  (* utc is monotonic *)
  IF CmpDTR( x, utc ) > 0 THEN
    utc := x;
  END;
END UpdDateTime;

PROCEDURE GetDateTime( VAR x: TDateTime );
BEGIN
  UpdDateTime();
  x := utc;
END GetDateTime;


PROCEDURE InitModule();
BEGIN
  Lib2.Fill( utc, 0 );
  GetDateTime( utc );
END InitModule;

BEGIN
  InitModule();
END UTCClk.
